﻿using UnityEngine;
using System.Collections;

public class EnemyCollision : MonoBehaviour {

	private bool isHit;
	private EnemyAI enemyStats;
	private PlayerStats playerStats;
    private setEnemyAppearance enemyLooks;
    private Color Original;

    void Start(){
		isHit = false;
		enemyStats = GameObject.Find ("Enemy").GetComponent<EnemyAI> ();
		playerStats = GameObject.Find ("Player").GetComponent<PlayerStats> ();
        enemyLooks = GameObject.Find("Enemy").GetComponent<setEnemyAppearance>(); // Access setAppearance object from characterDisplay
        Original = enemyLooks.getColor();
    }

	/*
	 * All enemy interactions handled here
	 */ 
	void OnTriggerEnter2D(Collider2D col){
		if (isHit == true) { // If hit recently, don't register hits
			return;
		}
		if (isHit == false) {
			if (col.tag == "currentWeapon") { // Enemy hits with slash attack
				isHit = true;
				enemyStats.Damage (playerStats.getDamageOutput());
                StartCoroutine(FlashRedWhenHit(0.1f));
                StartCoroutine (ExecuteAfterTime (1));
			}
			if (col.tag == "playerKick") { // Enemy hits with kick attack
				isHit = true;
				enemyStats.Damage (2);
                StartCoroutine (FlashRedWhenHit(0.1f));
				StartCoroutine (ExecuteAfterTime (0.2f));
			}
		}

	}
	/*
	 * After parameter time, sets player hitable again
	 */ 
	IEnumerator ExecuteAfterTime(float time){ 
		yield return new WaitForSeconds (time);
		isHit = false;
	}

    // After parameter time, sets player hitable again
    IEnumerator FlashRedWhenHit(float time) {
        yield return new WaitForSeconds(time);
        setEnemyAppearance.headR.color = new Color(1, 0, 0, 1);
        setEnemyAppearance.faceR.color = new Color(1, 0, 0, 1);
        setEnemyAppearance.bodyR.color = new Color(1, 0, 0, 1);
        setEnemyAppearance.legL.color = new Color(1, 0, 0, 1);
        setEnemyAppearance.legR.color = new Color(1, 0, 0, 1);
        setEnemyAppearance.armR.color = new Color(1, 0, 0, 1);
        setEnemyAppearance.forearmR.color = new Color(1, 0, 0, 1);
        yield return new WaitForSeconds(time);
        setEnemyAppearance.headR.color = new Color(255, 255, 255, 1);
        setEnemyAppearance.faceR.color = new Color(255, 255, 255, 1);
        setEnemyAppearance.bodyR.color = new Color(255, 255, 255, 1);
        setEnemyAppearance.legL.color = new Color(255, 255, 255, 1);
        setEnemyAppearance.legR.color = new Color(255, 255, 255, 1);
        setEnemyAppearance.armR.color = new Color(255, 255, 255, 1);
        setEnemyAppearance.forearmR.color = new Color(255, 255, 255, 1);
        /*
        yield return new WaitForSeconds(time);
        playerLooks.addColor(1, 0, 0);
        yield return new WaitForSeconds(time);
        playerLooks.addColor(255, 255, 255);
        */
        yield return new WaitForSeconds(time);
        setEnemyAppearance.headR.color = Original;
        setEnemyAppearance.faceR.color = Original;
        setEnemyAppearance.bodyR.color = Original;
        setEnemyAppearance.legL.color = Original;
        setEnemyAppearance.legR.color = Original;
        setEnemyAppearance.armR.color = Original;
        setEnemyAppearance.forearmR.color = Original;

    }



}
